
local function draw_status(x,y,src)

   local msg_table = {
      [1]  = "TempHigh",
      [2]  = "Trim Low",
      [3] = "SetIdle!",
      [4] = "Ready",
	  [5] = "Ignition",
      [6]  = "FuelRamp",
      [7] = "Glow Test",
      [8]  = "Running",
      [9] = "Stop",
      [10] = "FlameOut",
      [11] = "SpeedLow",
	  [12] = "Cooling",
	  [13] = "Ignitor Bad",
	  [14] = "Starter Bad",
	  [15] = "Weak Gas",
	  [16] = "Start On",
	  [17] = "User Off",
	  [18] = "Failsafe",
	  [19] = "Low RPM",
	  [20] = "Reset",
	  [21] = "Rx PwFail",
	  [22] = "Pre Heat",
	  [23] = "Battery!",
	  [24] = "Time Out",
	  [25] = "Overload",
	  [26] = "Ign.Fail",
	  [27] = "BurnerOn",
	  [28] = "Starting",
	  [29] = "SwitchOv",
	  [30] = "Cal.Pump",
	  [31] = "Pump Limit",
	  [32] = "NoEngine",
	  [33] = "PwrBoost",
	  [34] = "Run-Idle",
	  [35] = "Run-Max ",
	  [36] = "Restart ",
	  [0] = "No Status",
   }

   local status = getValue(src)
   if status==0 then
   status=status
   else
   status=status+1
   end
   local status_str = msg_table[status] or tostring(status)
      
   lcd.drawText(x+26,y+2,"STATUS",0)
   lcd.drawText(x+10,y+12,status_str,MIDSIZE+LEFT)
end

local function draw_rpm(x,y,src)
   local rpm = getValue(src)
   lcd.drawPixmap(x+40,y+2,"/IMAGES/rpm.bmp")
   lcd.drawText(x+72,y+8,"RPM",0)
   lcd.drawNumber(x+90,y+20,rpm,MIDSIZE+RIGHT)
end

local function draw_egt(x,y,src)
   local egt = getValue(src)
   lcd.drawPixmap(x+40,y+7,"/IMAGES/temp.bmp")
   lcd.drawText(x+73,y+4,"EGT",0)
   lcd.drawNumber(x+80,y+15,egt,MIDSIZE+RIGHT)
   lcd.drawText(x+90,y+15,"C",MIDSIZE+RIGHT)
end

local function draw_throttle(x,y,src)
   local throttle = getValue(src)
   --lcd.drawPixmap(x+4,y+14,"/IMAGES/rpm.bmp")
   lcd.drawText(x+3,y+7,"THROTT.",SMLSIZE)
   lcd.drawNumber(x+53,y+6,throttle,0+RIGHT)
   lcd.drawText(x+57,y+6,"%",0)
end

local function draw_fuel(x,y,src)
	local fuel = getValue(src)
	--lcd.drawPixmap(x+4,y+14,"/IMAGES/rpm.bmp")
	lcd.drawText(x+4,y+7,"FUEL",SMLSIZE)
	lcd.drawNumber(x+52,y+6,fuel,0+RIGHT)
	lcd.drawText(x+57,y+6,"%",0)
end


local function draw_battery(x,y,src)
   local batt_v = getValue(src)
   lcd.drawText(x+4,y+5,"V.BAT",SMLSIZE)
   --lcd.drawPixmap(x+4,y+3,"/IMAGES/battery.bmp")
   lcd.drawNumber(x+52,y+4,batt_v,PREC1+0+RIGHT)
   lcd.drawText(x+57,y+4,"V",0)
end

local function draw_pump(x,y,src)
   local pump = getValue(src)*100
   lcd.drawText(x+4,y+3,"PUMP",SMLSIZE)
   lcd.drawNumber(x+52,y+2,pump,PREC1+0+RIGHT)
   lcd.drawText(x+57,y+2,"V",0)
end

local function draw_name(x,y,src)
   local name = getValue(src)
   lcd.drawPixmap(x+6,y+7,"/IMAGES/logo.bmp")
   lcd.drawText(x+13,y+20,"ENGINE DATA",0)   
   --lcd.drawText(x+2,y+7,"      xicoy-9301 ",0)

end

local function run(event)

   -- local rpm    = 17408
   -- local egt    = '4400'
   -- local batt_v = "4403"
 
   local fuel   = "Fuel"
   local STATE = "STUS"
   local speed  = "RxBt"
   local name  = "Name"

   local fieldinfo = getFieldInfo('EGTC')
   local egt= fieldinfo['id']
   
   local fieldinfo = getFieldInfo('RPM1')
   local rpm= fieldinfo['id']
  
   local fieldinfo = getFieldInfo('THRT')
   local ecuth= fieldinfo['id']
   
   local fieldinfo = getFieldInfo('VBAT')
   local VBat= fieldinfo['id']
       
   local fieldinfo = getFieldInfo('PUMP')
   local VPump= fieldinfo['id']				

   local fieldinfo = getFieldInfo('FUEL')
   local remfuel= fieldinfo['id']   
  
   local fieldinfo = getFieldInfo('STAT')
   local STATE= fieldinfo['id'] 
             	 
   --local fieldinfo = getFieldInfo('4407')
   --local gps_speed= fieldinfo['id']            
   
   --local fieldinfo = getFieldInfo('4408')
   --local air_speed= fieldinfo['id']   
   
   --local fieldinfo = getFieldInfo('4409')
   --local baro_alt= fieldinfo['id']
   
   --local fieldinfo = getFieldInfo('4410')
   --local gps_alt= fieldinfo['id']
   

   lcd.clear()
   
--lcd.drawText(lcd.getLastPos()+2,11,fieldinfo['id'],0)


   draw_rpm(55,0,rpm)
   --draw_rpm()
    lcd.drawLine(88,0,88,63,DOTTED,FORCE)
   lcd.drawLine(0,35,87,35,DOTTED,FORCE)
   draw_egt(55,36,egt)


   lcd.drawLine(90,35,147,35,DOTTED,FORCE)
      
   draw_status(0,38,STATE)
   
   lcd.drawLine(149,18,211,18,DOTTED,FORCE)

   lcd.drawLine(148,0,148,63,DOTTED,FORCE)

   draw_throttle(149,0,ecuth)
   lcd.drawLine(149,35,211,35,DOTTED,FORCE)
   draw_fuel(149,18,remfuel)

   draw_battery(149,36,VBat)
   lcd.drawLine(149,51,211,51,DOTTED,FORCE)
   draw_pump(149,53,VPump)
   draw_name(0,0,name)

   
end

return {run=run}
